﻿using System.Data.Services;
using System.Data.Services.Common;
using CustomerOrder.Entities;
using DataLayer;

namespace CustomerDataServices
{
  public class CustomerDataService : DataService<CustomerOrderContext>
  {
    public static void InitializeService(DataServiceConfiguration config)
    {
      config.SetEntitySetAccessRule("*", EntitySetRights.AllRead);
      config.SetEntitySetAccessRule("Customers", EntitySetRights.AllRead | EntitySetRights.WriteMerge);
      config.SetEntitySetAccessRule("EdmMetadatas", EntitySetRights.None);
      config.UseVerboseErrors = true;
      config.DataServiceBehavior.MaxProtocolVersion = DataServiceProtocolVersion.V3;
    }
  }
}

