using System;
using System.Collections.Generic;

namespace CustomerOrder.Entities
{
public class Customer: DateClass
{
	  public Customer()
	{
    _addresses = new List<Address>();
    _orders = new List<Order>();
	}

	public int CustomerId { get; set; }
	public string Title { get; set; }
	public string FirstName { get; set; }
	public string MiddleName { get; set; }
	public string LastName { get; set; }
	public string CompanyName { get; set; }
	public string EmailAddress { get; set; }
	public string Phone { get; set; }
	public byte[] TimeStamp { get; set; }
	public string FullName
	{
    get {return FirstName + " " + LastName; }
	}
	public string FullNameReverse
	{
	  get {return LastName + ", " + FirstName;}
	}
	private ICollection<Address> _addresses;
	public virtual ICollection<Address> Addresses
	{
	  get { return _addresses; }
	  set { _addresses = value; }
	}

	private ICollection<Order> _orders;
	public virtual ICollection<Order> Orders
	{
	  get { return _orders; }
	  set { _orders = value; }
	}
}
}

