using System;
using System.Collections.Generic;

namespace CustomerOrder.Entities
{
  public class LineItem : DateClass
  {
    public int OrderId { get; set; }
    public int LineItemId { get; set; }
    public int OrderQty { get; set; }
    public int ProductId { get; set; }
    public decimal UnitPrice { get; set; }
    public Nullable<decimal> UnitPriceDiscount { get; set; }
    public decimal LineTotal
    {
      get
      {
        if (UnitPriceDiscount==null)
        {
          return (OrderQty*UnitPrice);
        }
        return (decimal) (OrderQty * (UnitPrice - UnitPriceDiscount));
      }
    }
    public virtual Product Product { get; set; }
    public Order Order { get; set; }
  }
}

