using System;
using System.Collections.Generic;

namespace CustomerOrder.Entities
{
	public class Order :DateClass
	{
	  public Order()
		{
      _lineItems = new List<LineItem>();
		}

		public int OrderId { get; set; }
		public DateTime OrderDate { get; set; }
		public Nullable<DateTime> DueDate { get; set; }
		public bool OnlineOrderFlag { get; set; }
		public string SalesOrderNumber { get; set; }
		public string PurchaseOrderNumber { get; set; }
		public int CustomerId { get; set; }
		public Nullable<int> BillToAddressId { get; set; }
		public decimal SubTotal { get; set; }
		public string Comment { get; set; }
		public Nullable<DateTime> ShipDate { get; set; }
		public Customer Customer { get; set; }

	  private ICollection<LineItem> _lineItems;
	  public virtual ICollection<LineItem> LineItems
	  {
	    get { return _lineItems; }
	    set { _lineItems = value; }
	  }
	}
}

