using System;
using System.Collections.Generic;

namespace CustomerOrder.Entities
{
	public class Product
	{
	    public Product()
		{
      _lineItems = new List<LineItem>();
		}

		public int ProductId { get; set; }
		public string Name { get; set; }
		public string ProductNumber { get; set; }
		public string Color { get; set; }
		public decimal StandardCost { get; set; }
		public decimal ListPrice { get; set; }
		public Nullable<int> CategoryID { get; set; }
		public Nullable<int> ModelID { get; set; }
		public Nullable<DateTime> DiscontinuedDate { get; set; }
		public byte[] ThumbNailPhoto { get; set; }
		public string ThumbnailPhotoFileName { get; set; }
		public virtual Category ProductCategory { get; set; }
		public virtual ProductModel ProductModel { get; set; }
	  private ICollection<LineItem> _lineItems;
	  public virtual ICollection<LineItem> LineItems
	  {
	    get { return _lineItems; }
	    set { _lineItems = value; }
	  }
	}
}

