using System;
using System.Data.Entity.ModelConfiguration;
using System.Data.Common;
using System.Data.Entity;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using TestEFPowerToolsCTP1.Entities;

namespace TestEFPowerToolsCTP1.Mapping
{
	public class CustomerAddressMap : EntityTypeConfiguration<CustomerAddress>
	{
		public CustomerAddressMap()
		{
			// Primary Key
			this.HasKey(t => new { t.CustomerID, t.AddressID });

			// Properties
			this.Property(t => t.CustomerID)
				.HasDatabaseGeneratedOption(DatabaseGeneratedOption.None);
				
			this.Property(t => t.AddressID)
				.HasDatabaseGeneratedOption(DatabaseGeneratedOption.None);
				
			this.Property(t => t.AddressType)
				.IsRequired()
				.HasMaxLength(50);
				
			// Table & Column Mappings
			this.ToTable("CustomerAddress");
			this.Property(t => t.CustomerID).HasColumnName("CustomerID");
			this.Property(t => t.AddressID).HasColumnName("AddressID");
			this.Property(t => t.AddressType).HasColumnName("AddressType");
			this.Property(t => t.ModifiedDate).HasColumnName("ModifiedDate");

			// Relationships
			this.HasRequired(t => t.Address)
				.WithMany(t => t.CustomerAddresses)
				.HasForeignKey(d => d.AddressID);
				
			this.HasRequired(t => t.Customer)
				.WithMany(t => t.CustomerAddresses)
				.HasForeignKey(d => d.CustomerID);
				
		}
	}
}

