using System;
using System.Data.Entity.ModelConfiguration;
using System.Data.Common;
using System.Data.Entity;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using TestEFPowerToolsCTP1.Entities;

namespace TestEFPowerToolsCTP1.Mapping
{
	public class LineItemMap : EntityTypeConfiguration<LineItem>
	{
		public LineItemMap()
		{
			// Primary Key
			this.HasKey(t => t.LineItemID);

			// Properties
			// Table & Column Mappings
			this.ToTable("LineItems");
			this.Property(t => t.OrderID).HasColumnName("OrderID");
			this.Property(t => t.LineItemID).HasColumnName("LineItemID");
			this.Property(t => t.OrderQty).HasColumnName("OrderQty");
			this.Property(t => t.ProductID).HasColumnName("ProductID");
			this.Property(t => t.UnitPrice).HasColumnName("UnitPrice");
			this.Property(t => t.UnitPriceDiscount).HasColumnName("UnitPriceDiscount");
			this.Property(t => t.LineTotal).HasColumnName("LineTotal");
			this.Property(t => t.ModifiedDate).HasColumnName("ModifiedDate");

			// Relationships
			this.HasOptional(t => t.Product)
				.WithMany(t => t.LineItems)
				.HasForeignKey(d => d.ProductID);
				
			this.HasRequired(t => t.Order)
				.WithMany(t => t.LineItems)
				.HasForeignKey(d => d.OrderID);
				
		}
	}
}

