﻿using System.ComponentModel;
using System.Windows;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;

namespace WP7App
{
  public partial class DetailsPage : PhoneApplicationPage
  {
    private int _orderId;
    private int _orderIndex;
    public DetailsPage()
    {
      InitializeComponent();
      App.ViewModel.PropertyChanged += new PropertyChangedEventHandler(RefreshControls);
      this.Loaded += new RoutedEventHandler(DetailsPage_Loaded);
    }

    // When page is navigated to set data context to selected item in list
    protected override void OnNavigatedTo(NavigationEventArgs e)
    {
      string selectedIndex = "";
      if (NavigationContext.QueryString.TryGetValue("selectedItem", out selectedIndex))
      {
        _orderIndex = int.Parse(selectedIndex);
        DataContext = App.ViewModel.LineItems;
        _orderId = (App.ViewModel.Orders[_orderIndex]).OrderId;
      }
    }

    private void DetailsPage_Loaded(object sender, RoutedEventArgs e)
    {
        App.ViewModel.LoadLineItems(_orderId);

    }
    public void RefreshControls(object sender, PropertyChangedEventArgs e)
    {
      Dispatcher.BeginInvoke(() => ListTitle.Text=App.ViewModel.CurrentOrderNumber + " Items");
      Dispatcher.BeginInvoke(() => lstLineItems.ItemsSource = App.ViewModel.LineItems);

    }
  }
}