﻿using System.Linq;
using DataLayer;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using CustomerOrder.Entities;
using System.Data.Entity;

namespace TestProject1
{
  
  [TestClass()]
  public class AWContextTest
  {

      public AWContextTest()
      {
        Database.SetInitializer(new MyInitializer());
      }

  
    [TestMethod()]
    public void CustomersTest()
    {
      var target = new CustomerOrderContext();

      Assert.IsNotNull(target.Customers.ToList());
    }
    [TestMethod]
    public void CanInsertNewCustomerAndOrder()
    {
      
      var db = new CustomerOrderContext();
      
      var custCount = db.Customers.Count();
      var orderCount = db.Orders.Count();
      var customer = new Customer {FirstName = "Julie", LastName = "Lerman"};
      
      db.Customers.Add(customer);
      customer.Orders.Add(new Order
                            {
                             SalesOrderNumber = "12345",
                              DueDate = DateTime.Today + new TimeSpan(30, 0, 0, 0),
                              OrderDate = DateTime.Today
                            }
                              );
      db.SaveChanges();
      
      db = new CustomerOrderContext();
      Assert.IsTrue(db.Customers.Count() == custCount+1);
      Assert.IsTrue(db.Orders.Count() == orderCount+1);
    }
  }
}
